<template>
  <ul class="list_box">
    <li v-for="item in props.menuData" :key="item.key">
      <div
        @click="itemClick(item)"
        :class="[{ children: item.children }, { select: itemSelect === item.key }]"
      >
        {{ item.text }}
      </div>

      <DropdownMenu
        v-if="item.children && itemSelect === item.key"
        :menuData="item.children"
        :keyPath="keyPath"
      />
    </li>
  </ul>
</template>

<script setup lang="ts">
import type { MenuData } from '@/model/menu'
import { useCounterStore } from '@/stores/counter'

const itemSelect = ref('')
const props = defineProps<{
  menuData: MenuData[]
  keyPath: string[] | null
}>()

let keyPath = props.keyPath

onMounted(() => {
  if (keyPath) {
    itemSelect.value = keyPath.shift() ?? ''
  }
})

watch(props, () => {
  keyPath = props.keyPath
  if (keyPath) {
    itemSelect.value = keyPath.shift() ?? ''
  }
})

function itemClick(item: MenuData) {
  if (itemSelect.value === item.key) {
    if (item.children) {
      //收合
      itemSelect.value = ''
    }
  } else {
    itemSelect.value = item.key
    useCounterStore().selectKey = item.key
    localStorage.setItem('itemSelect', item.key)
  }
}
</script>

<style lang="scss"></style>
